package rankine;
import java.awt.Button;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import resourcemanager.WordMap;

//--------------------------------------------------------------------//
/**
 * `{^
 */
public class DrawDiagramButton extends Button implements ActionListener{

/** \LoX */
  protected RankineCycleCanvas canvas;

/** ሳ P1 ͂ <code>TextField</code> */
  protected TextField p1;

/**  P2 ͂ <code>TextField</code> */
  protected TextField p2;

/** ^[rCx T3 ͂ <code>TextField</code> */
  protected TextField t3;

/**
 * `{^\z
 * @param canvas \LoX
 * @param p1 ሳ P1 ͂ <code>TextField</code>
 * @param p2  P2 ͂ <code>TextField</code>
 * @param t3 ^[rCx T3 ͂ <code>TextField</code>
 */
  public DrawDiagramButton(RankineCycleCanvas canvas,TextField p1,
      	      	      	   TextField p2,TextField t3){
    super(WordMap.get(WordMap.DRAW));
    this.canvas=canvas;
    this.p1=p1;
    this.p2=p2;
    this.t3=t3;
    addActionListener(this);
  }

//--------------------------------------------------------------------//
/**
 * ĕ`悷
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    try{
      double pp1=Double.parseDouble(p1.getText());
      double pp2=Double.parseDouble(p2.getText());
      double tt3=Double.parseDouble(t3.getText());
      canvas.getRankineCycle().setCondition(pp1,pp2,tt3);
      canvas.getRankineCycle().createDiagram();
      canvas.setGraphData();
      canvas.setMessage(null);
    }
    catch(Exception ex){
      canvas.setMessage(ex.getMessage());
    }
    canvas.repaint();
  }
}
