package rankine.graph;
import java.awt.FontMetrics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.util.ArrayList;

//--------------------------------------------------------------------//
/**
 * eLXg{bNX
 */
public class TextBox extends Rectangle{

/** ] */
  public static final int MARGIN=2;

/** i[郊Xg */
  protected ArrayList list;

/**
 * eLXg{bNX
 */
  public TextBox(){
    super();
    list=new ArrayList();
  }

//--------------------------------------------------------------------//
/**
 * ǉ
 * @param t ǉ镶
 */
  public void addText(String t){
    list.add(t);
  }

//--------------------------------------------------------------------//
/**
 * 
 */
  public void clear(){
    list.clear();
  }

//--------------------------------------------------------------------//
/**
 * eLXg{bNX̃TCYݒ肷
 * @param fm tHggbNX
 */
  public void setSize(FontMetrics fm){
    int size=list.size();
    width=0;
    height=fm.getHeight()*size;
    for(int i=0;i<size;i++){
      width=Math.max(width,fm.stringWidth((String)list.get(i)));
    }
    width+=2*MARGIN;
  }

//--------------------------------------------------------------------//
/**
 * Ot`悷
 * @param g `悷OtBbNXReLXg
 */
  public void paint(Graphics2D g){
    if((width==0) || (height==0)) return;
    g.drawRect(x,y,width,height);
    FontMetrics fm=g.getFontMetrics();
    int h=fm.getHeight();
    int size=list.size();
    int yy=y+fm.getAscent();
    for(int i=0;i<size;i++){
      g.drawString((String)list.get(i),x+MARGIN,yy);
      yy+=h;
    }
  }
}
