package rankine.steamtable;

//--------------------------------------------------------------------//
/**
 * ԗ
 */
public class StateVariable extends VaporVariable{

/** x */
  public double t;

/**  */
  public double p;

/**
 * ԗʂ\z
 * @param t x
 * @param p 
 * @param v e
 * @param u GlM[
 * @param h G^s[
 * @param s Ggs[
 */
  public StateVariable(double t,double p,double v,double u,double h,
      	      	       double s){
    super(v,u,h,s);
    this.t=t;
    this.p=p;
  }

/**
 * ԗʂ\z
 * @param t x
 * @param p 
 * @param vv Cp[^
 */
  public StateVariable(double t,double p,VaporVariable vv){
    super(vv.v,vv.u,vv.h,vv.s);
    this.t=t;
    this.p=p;
  }

//--------------------------------------------------------------------//
/**
 * lݒ肷
 * @param t x
 * @param p 
 * @param v e
 * @param u GlM[
 * @param h G^s[
 * @param s Ggs[
 */
  public void set(double t,double p,double v,double u,double h,
      	      	  double s){
    set(v,u,h,s);
    this.t=t;
    this.p=p;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long lt=Double.doubleToLongBits(t);
    long lp=Double.doubleToLongBits(p);
    int bit=super.hashCode();
    bit=31*bit+(int)(lt^(lt>>>32));
    bit=31*bit+(int)(lp^(lp>>>32));
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>StateVariable</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof StateVariable){
      StateVariable sv=(StateVariable)obj;
      return ((t==sv.t) && (p==sv.p) && super.equals(sv));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return t+"\t"+p+"\t"+u+"\t"+v+"\t"+h+"\t"+s;
  }
}
