package resourcemanager;
import java.io.InputStream;
import java.io.IOException;
import java.net.URL;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;

//--------------------------------------------------------------------//
/**
 * gpPǗNX
 */
public class WordMap extends XMLDataMap{

/** gpPf[^̃t@C */
  public static String FILE_NAME="/resource/word.xml";

/** ሳ͂\ */
  public static final String PRESS1="pressure1";

/** ͂\ */
  public static final String PRESS2="pressure2";

/** ^[rCx\ */
  public static final String TEMP3="temperature3";

/** ቷx\ */
  public static final String TEMP1="temperature1";

/** {C[ŉMʂ\ */
  public static final String Q1="q1";

/** ŕMMʂ\ */
  public static final String Q2="q2";

/** |vd\ */
  public static final String WP="wp";

/** ^[rd\ */
  public static final String WT="wt";

/** M\ */
  public static final String EFFICIENCY="efficiency";

/** ͂̒Pʂ\ */
  public static final String PRESS_UNIT="pressunit";

/** x̒Pʂ\ */
  public static final String TEMP_UNIT="tempunit";

/** x̒Pʂ\ */
  public static final String TEMP_UNIT2="tempunit2";

/** ̐ς̒Pʂ\ */
  public static final String VOLUME_UNIT="volunit";

/** GlM[̒Pʂ\ */
  public static final String ENERGY_UNIT="energyunit";

/** Ggs[̒Pʂ\ */
  public static final String ENTOROPY_UNIT="entropyunit";

/** `\ */
  public static final String DRAW="draw";

/** x1\ */
  public static final String WARNING1="warning1";

/** x2\ */
  public static final String WARNING2="warning2";

/** x3\ */
  public static final String WARNING3="warning3";

/** x4\ */
  public static final String WARNING4="warning4";

/** x5\ */
  public static final String WARNING5="warning5";

/** f[^i[}bv */
  private static WordMap current=new WordMap();

/** sNX */
  protected Class cls;

/**
 * gpPǗIuWFNg\z
 */
  public WordMap(){
    super();
    cls=getClass();
  }

//--------------------------------------------------------------------//
/**
 * f[^ URL Ԃ
 * @param name t@C
 * @return f[^ URL
 */
  public URL getURL(String name){
    return cls.getResource(name);
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read()
    throws ParserConfigurationException,SAXException,IOException{
    read(current.getURL(FILE_NAME));
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @param url f[^ URL
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(URL url)
    throws ParserConfigurationException,SAXException,IOException{
    current.readFromURL(url);
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @param is ̓Xg[
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(InputStream is)
    throws ParserConfigurationException,SAXException,IOException{
    current.readFromStream(is);
  }

//--------------------------------------------------------------------//
/**
 * gpPԂ
 * @param key P̃L[
 * @return P
 */
  public static String get(String key){
    return current.getName(key);
  }
}
